#ifndef CLASSEDITOR_H
#define CLASSEDITOR_H

#include <QMainWindow>
#include "mysql.h"
#include "mymodel.h"
#include "modelfordescriptiontable.h"
#include "delegateforclassestable.h"
#include "modelforpointers.h"
#include "delegate.h"
#include "settingform.h"

#include <QTreeView>


namespace Ui {
    class ClassEditor;
}

class ClassEditor : public QMainWindow {
    Q_OBJECT
public:
    ClassEditor(QWidget *parent = 0);
    ~ClassEditor();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::ClassEditor *ui;

    settingForm setFrm;

    QString baseName;
    QString hostName;
    QString userName;
    QString password;
    QString tableName;

    void readSettings();
    void writeSettings();



    MySql sql;
    SettingsDialog settdialog;
    TableField *field;
    SqlTable *table;
    QModelIndex currIndexOfClassesTable; //      
    QString currClassID; //   
    QString currInctanceTable; //  -    

    QSqlTableModel* model;


   // QSqlTableModel* modelForPointers; //     
    ModelForPointers* modelForPointers; //     

    // QSqlTableModel* modelForDescription;
    ModelForDescriptionTable* modelForDescription;

    QSqlTableModel* Inctance_model;

    QTableView* tableForDescription;
    MyModel* mymodel;

    QTableView* tableForInstance; //    -  
    QTableView tableForInstance_new; //    -  

    DelegateForClassesTable classTableDelegate;
    SpinBoxDelegate delegateForDefaultValueColomn;

  //  void addNewClass(); //   
    void addNewClass_new();
    void addNewField(); //     
    void addNewPointer();//  ,       -
    void refreshInctance(); //   -
    void initDataBase(); //      


private slots:

    void on_pushButton_clicked();           //    " "
    void on_pushButton_2_clicked();         //    " "
    void on_pushButton_3_clicked();         //    " "
    void on_pushButton_4_clicked();         //    " "
    void on_pushButton_5_clicked();         //    "  "
    void on_action_ID_triggered(bool is_checked);          //     " ID"
    void on_action_showAlias_triggered(bool is_checked);     //     " "
    void on_action_showInstance_triggered(bool is_checked); // ...   

    void on_tableView_clicked(const QModelIndex & index );
    void on_myModel_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight );
    void on_modelForDescription_dataChanged ( const QModelIndex & topLeft, const QModelIndex & bottomRight );
    void on_action_removeAllClasses(); //   
    void on_action_removeSelectedPointers(); //   

    void removeClass(int class_row); //   ,      class_row
    void on_field_changed(); //   
    void on_action_newPointer(); //     -

    void applySetting();
    void getSetting(); //   



};

#endif // CLASSEDITOR_H
